package arm;

import iron.math.Vec3;
import iron.math.Vec4;
import iron.Scene;
import armory.trait.physics.bullet.PhysicsWorld;
import iron.system.Input;

class CameraBmberHaxe extends iron.Trait {
	public function new() {
		super();
		var physics = PhysicsWorld.active;
		var planeFront = Scene.active.getChild('PlaneFront');
		var planeBack = Scene.active.getChild('PlaneBack');
		var player = Scene.active.getChild('Player');
		var hit;
		var cameraDistance = 7.0;
		var margin = -0.05;

		//notifyOnInit(function() {
		//});

		notifyOnUpdate(function() {
			hit = physics.rayCast(player.transform.world.getLoc(), planeFront.transform.world.getLoc());
			if(hit == null)
			{
				hit = physics.rayCast(planeFront.transform.world.getLoc(), planeBack.transform.world.getLoc());
				if(hit == null)
				{
					if(cameraDistance > object.transform.world.getLoc().distanceTo(player.transform.world.getLoc()))
					{
						object.transform.move(object.transform.local.up(),0.05);
					}
				}
			}
			else 
			{
				var newLen = player.transform.world.getLoc().distanceTo(planeFront.transform.world.getLoc()) - player.transform.world.getLoc().distanceTo(hit.pos);
				object.transform.move(object.transform.local.up(), -(newLen));
			}
			
		});

		// notifyOnRemove(function() {
		// });
	}
}
